<?xml version="1.0"?>
<!--

Officity - Web application platform - Version 6.0 - 2011-07-05

François Dispaux, Boris Verdeyen, Thomas Hermant,
Jérémie Roy, Grégory Meurice, Abdelila Harbi, 
Marc Mignonsin, Jonathan Sanchez, Julien Gonzalez, Pierre Fouchez

Sushee and Officity is © Copyright 2011 Nectil SA.

`/var/www/installer/public_html/officity-source/apps/officity/factory/HomePanel.xsl` is part of Officity.

Sushee is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Officity and Sushee are distributed in the hope that they will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Sushee. If not, see <http://www.gnu.org/licenses/>.

-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:OFFICITY="http://officity.com">
    <xsl:import href="app.include.xsl"/>
    <xsl:output encoding="UTF-8" method="xml" indent="no"/>
    <xsl:strip-space elements="*"/>
    
    <!-- parameters -->
    <xsl:param name="targetModule" select="/RESPONSE/URL/targetModule"/>

	<xsl:template match="/RESPONSE">
    	<xsl:call-template name="panel-navigation" />
    </xsl:template>
	
	<xsl:template name="panel-body-navigation">  
        <xsl:call-template name="staticitemheader">
            <xsl:with-param name="title">Factory</xsl:with-param>
            <xsl:with-param name="icon">../system/images/icons/factory-32.png</xsl:with-param>
            <xsl:with-param name="info">
            	<xsl:text>The Factory application provides a set of tools to create and manage business applications and data.</xsl:text>
            </xsl:with-param>
        </xsl:call-template>
        
        <xsl:call-template name="navigationitem">
            <xsl:with-param name="title">Environments</xsl:with-param>
            <xsl:with-param name="panelURI">environments/Index</xsl:with-param>
            <xsl:with-param name="icon">../system/images/icons/environment/env.png</xsl:with-param>
            <xsl:with-param name="params">
            </xsl:with-param>
        </xsl:call-template>
        
        <xsl:call-template name="navigationitem">
            <xsl:with-param name="title">Editors</xsl:with-param>
            <xsl:with-param name="panelURI">namespaces/Index</xsl:with-param>
            <xsl:with-param name="icon">../system/images/icons/namespace/namespace-16.png</xsl:with-param>
            <xsl:with-param name="params">
            	<xsl:text>module:'namespace'</xsl:text>
            </xsl:with-param>
        </xsl:call-template>
        
        <!--xsl:call-template name="navigationitem">
            <xsl:with-param name="title">Publishers</xsl:with-param>
            <xsl:with-param name="panelURI">publishers/Index</xsl:with-param>
            <xsl:with-param name="icon">../system/images/icons/publish/publisher.png</xsl:with-param>
            <xsl:with-param name="params">
            </xsl:with-param>
        </xsl:call-template-->
        
        <xsl:call-template name="navigationitem">
            <xsl:with-param name="title">Applications</xsl:with-param>
            <xsl:with-param name="panelURI">applications/Index</xsl:with-param>
            <xsl:with-param name="icon">../system/images/icons/applications/applications.png</xsl:with-param>
            <xsl:with-param name="params">
            	<xsl:text>module:'app'</xsl:text>
            </xsl:with-param>
        </xsl:call-template>
        
        <xsl:call-template name="navigationitem">
            <xsl:with-param name="title">Modules</xsl:with-param>
            <xsl:with-param name="panelURI">modules/Index</xsl:with-param>
            <xsl:with-param name="icon">../system/images/icons/modules/module-16.png</xsl:with-param>
            <xsl:with-param name="params">
            </xsl:with-param>
        </xsl:call-template>
        
        <xsl:call-template name="navigationitem">
            <xsl:with-param name="title">Publisher</xsl:with-param>
            <xsl:with-param name="panelURI">publish/Index</xsl:with-param>
            <xsl:with-param name="icon">../system/images/icons/publish/publish-16.png</xsl:with-param>
            <xsl:with-param name="params">
            </xsl:with-param>
        </xsl:call-template>
        
        <xsl:call-template name="navigationitem">
            <xsl:with-param name="title">System info</xsl:with-param>
            <xsl:with-param name="panelURI">../../system/tools/info/system.info</xsl:with-param>
            <xsl:with-param name="params"></xsl:with-param>
            <xsl:with-param name="icon">../system/images/icons/info.png</xsl:with-param>
            <xsl:with-param name="info"></xsl:with-param>
        </xsl:call-template>
        
        <xsl:call-template name="dev-tools" />
	</xsl:template>
</xsl:stylesheet>