<?xml version="1.0"?>
<!--

Officity - Web application platform - Version 6.0 - 2011-07-05

François Dispaux, Boris Verdeyen, Thomas Hermant,
Jérémie Roy, Grégory Meurice, Abdelila Harbi, 
Marc Mignonsin, Jonathan Sanchez, Julien Gonzalez, Pierre Fouchez

Sushee and Officity is © Copyright 2011 Nectil SA.

`/var/www/installer/public_html/officity-source/apps/officity/lib/HomePanel.xsl` is part of Officity.

Sushee is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Officity and Sushee are distributed in the hope that they will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Sushee. If not, see <http://www.gnu.org/licenses/>.

-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:OFFICITY="http://officity.com">
    <xsl:import href="app.include.xsl"/>
    <xsl:output encoding="UTF-8" method="xml" indent="no"/>
    <xsl:strip-space elements="*"/>
    
    <!-- parameters -->
    <!--xsl:param name="param" select="/RESPONSE/URL/value"/-->

	<xsl:template match="/RESPONSE">
    	<xsl:call-template name="panel-navigation">
    	</xsl:call-template>
    </xsl:template>
	
	<!-- navigation body -->
	<xsl:template name="panel-body-navigation">
        <xsl:call-template name="staticitemheader">
            <xsl:with-param name="title">Home panel</xsl:with-param>
            <xsl:with-param name="icon">../system/images/icons/applications/application-32.png</xsl:with-param>
            <xsl:with-param name="info">
            	<xsl:text>This is the home panel of your new application. (...)</xsl:text>
            </xsl:with-param>
        </xsl:call-template>
        
	    <xsl:call-template name="navigationitem">
	        <xsl:with-param name="title">Basic panel template</xsl:with-param>
	        <xsl:with-param name="panelURI">templates/BasicPanel</xsl:with-param>
	        <xsl:with-param name="params">parm:'parm'</xsl:with-param>
	        <xsl:with-param name="icon">
	            <xsl:text>../system/images/icons/documents/document.png</xsl:text>
	        </xsl:with-param>
	    </xsl:call-template>
	
	    <xsl:call-template name="navigationitem">
	        <xsl:with-param name="title">Navigation panel template</xsl:with-param>
	        <xsl:with-param name="panelURI">templates/NavPanel</xsl:with-param>
	        <xsl:with-param name="params">parm:'parm'</xsl:with-param>
	        <xsl:with-param name="icon">
	            <xsl:text>../system/images/icons/navigation/arrow-black.png</xsl:text>
	        </xsl:with-param>
	    </xsl:call-template>
	
        <xsl:call-template name="appmodules-tools">
        	<xsl:with-param name="modules" select="/RESPONSE/RESULTS[@name='appModules']/MODULE" />
        </xsl:call-template>
    </xsl:template>
</xsl:stylesheet>